#ifndef POSE_ESTIMATION_H
#define POSE_ESTIMATION_H

#include<stdio.h>
#include"opencv2/opencv.hpp"
#include"position_heading_calculation.hpp"
#include"marker_detection.hpp"

struct marker_real_t
{
	int code;
	std::vector<cv::Point3f> pts;
};

bool estimate_pose(std::vector<cv::Point2f> img_pts, std::vector<cv::Point3f> real_pts, cv::Mat& trans_cam_scene);

bool get_real_pts(std::string quay_name, std::vector<marker_t>& detected_markers, std::vector<cv::Point2f>& img_pts, std::vector<cv::Point3f>& real_pts, std::vector<int>& detected_codes);

bool load_quay_information(std::string quay_name, std::vector<marker_real_t>& real_pts);

std::string type2str(int type);

#endif