#ifndef POSITION_ORIENTATION_H
#define POSITION_ORIENTATION_H

struct position_t
{
 	float Latitude;
 	float Longitude;
 	float Altitude;
 	float Heading;
}; 

struct pose_t
{
	double x;
	double z;
	double psi;
};

position_t calculate_position_heading(cv::Mat Trans_quay_camera);

void calculate_position(position_t& ship_pose,cv::Mat Trans_ECEF_quay, cv::Mat Trans_quay_camera, cv::Mat Trans_camera_ship);

void calculate_heading(position_t& ship_pose);

cv::Vec4f change_point_coordinate_frame(cv::Mat transformation, cv::Vec4f point);

void geotoECEF(cv::Mat Quay_geodetic_position, cv::Vec4f& Quay_ECEF_position);

void getTransECEFtoQ(cv::Vec4f Quay_ECEF_position, cv::Mat& trans);

void ECEFtoGeo(cv::Vec4f ECEF_point, position_t& ship_pose);

void calculatePose(pose_t& camera_pose, cv::Mat transformationCameraScene);

#endif