#include <stdio.h>
#include "opencv2/opencv.hpp"

#include"../headers/tracking.hpp"

bool tracking::track_points(cv::Mat prev_img, cv::Mat next_img, std::vector<cv::Point2f> prev_points, std::vector<cv::Point2f>& next_points, std::vector<int>& detected_codes, std::vector<cv::Point3f>& real_points)
{
	std::vector<uchar> status;
	std::vector<float> err;
	std::vector<int> delete_list;
	cv::Size winSize(31,31);
	cv::TermCriteria termcrit(cv::TermCriteria::COUNT|cv::TermCriteria::EPS,30,0.03);

	if (!prev_img.empty() && !next_img.empty())
	{

		cv::calcOpticalFlowPyrLK(prev_img, next_img, prev_points, next_points, status, err, winSize,5, termcrit, 0, 0.001);
		
		for (int i = 0 ; i < detected_codes.size() ; i++)
		{
			
			int s = i*4;
			if((int(status[s])==0)||(int(status[s+1])==0)||(int(status[s+2])==0)||(int(status[s+3])==0))
			{
				
				delete_list.push_back(i);
			}
		}

		for (int dl_i = delete_list.size()-1; dl_i >= 0; --dl_i)
		{
			int s = delete_list[dl_i]*4;
			next_points.erase(next_points.begin()+s, next_points.begin()+s+4);
			real_points.erase(real_points.begin()+s, real_points.begin()+s+4);
			detected_codes.erase(detected_codes.begin()+delete_list[dl_i]);
		}
		return true;
	}
	else{
		return false;
	}
}